<script>
	export let chartType
	export let observationsByTerritoryCode
	export let title
	export let width

	import { CHART_TYPE, NA } from "~/indicator.js"
	import { territoriesMetadata } from "~/stores.js"
	import Plotly from "./Plotly.svelte"
	import Pyramid from "./pyramid/Pyramid.svelte"

	function getCleanObservations() {
		return Object.entries(observationsByTerritoryCode).reduce(
			(acc, [territoryCode, observations]) => {
				let period = []
				let value = []
				for (const [index, currentValue] of observations.value.entries()) {
					if (currentValue === NA) {
						continue
					}
					value.push(currentValue)
					period.push(observations.period[index])
				}
				acc[territoryCode] = { value, period }
				return acc
			},
			{},
		)
	}

	$: cleanObservations = chartType === CHART_TYPE.LINE && getCleanObservations()

	$: hasData =
		chartType === CHART_TYPE.LINE
			? Object.values(cleanObservations).some(
					(observations) => observations.period.length > 0,
			  )
			: Object.values(observationsByTerritoryCode).some(
					(observations) => Object.keys(observations).length > 0,
			  )

	function getLineChartData() {
		return Object.entries(cleanObservations).map(
			([territoryCode, observations]) => ({
				x: observations.period,
				y: observations.value,
				name: $territoriesMetadata.getTerritoryName(territoryCode),
				type: "scatter",
				connectgaps: true,
			}),
		)
	}

	$: layout = {
		margin: {
			t: 32,
			l: 32,
			r: 32,
		},
		showlegend: true,
		legend: {
			orientation: "h",
		},
		modebar: {
			orientation: "v",
		},
		width,
		title: title,
	}

	$: config = {
		toImageButtonOptions: {
			filename: title,
		},
	}
</script>

{#if !hasData}
	<div class="flex h-full items-center justify-center border-2 rounded">
		Aucune donnée disponible
	</div>
{:else if chartType === CHART_TYPE.LINE}
	<Plotly data={getLineChartData()} {layout} {config} />
{:else if chartType === CHART_TYPE.PYRAMID}
	{#each Object.entries(observationsByTerritoryCode) as [territoryCode, { observations, legend }], index}
		{#if index > 0}
			<hr class="mt-8 mb-4" />
		{/if}
		<div class="mb-4">
			{$territoriesMetadata.getTerritoryName(territoryCode)}
		</div>
		<Pyramid {observations} {legend} />
	{/each}
{/if}
